using System.Collections.Generic;

namespace Siberix.Examples
{
	using System;

	class Example
	{
		static void Main(string[] args)
		{
			// Report
			Siberix.Report.Report report = new Siberix.Report.Report();

			// Info
			report.Info.Title = "Example";
			report.Info.Author = "Siberix Technologies, Canada";
			report.Info.Creator = "Siberix Report Writer";
			report.Info.Copyright = "2003-2012 Siberix Technologies, Canada";

			// Section
			Siberix.Report.Section.ISection section = report.AddSection();
			section.Size = Siberix.Report.PageSize.Letter;
			section.Spacings.All = 35;

			// Styles
			Siberix.Report.Text.Style style1 = new Siberix.Report.Text.Style(new Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black);

			Siberix.Report.Text.Style style2 = new Siberix.Report.Text.Style(new Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Red);
			style2.FontVariant = Siberix.Report.FontVariant.Subscript;

			System.Random rnd = new System.Random();

			for (int i = 1; i < 26; i++)
			{
				// Group
				Siberix.Report.IGroup group = section.AddGroup();
				group.Borders = new Siberix.Report.Borders(new Siberix.Graphics.Pen(Siberix.Graphics.Colors.Black, 1.5F), 5);
				group.Background.Brush = Siberix.Graphics.Brushes.Azure;
				group.Width = new Siberix.Report.RelativeWidth(35.0F + (float)(65.0 * rnd.NextDouble()));
				group.Paddings.All = 5;
				group.Spacings.Bottom = 5;

				Siberix.Report.Text.IText text = group.AddText();
				text.Style = style1;
				text.AddContent("Group");
				text.AddContent(i.ToString(), style2);

				int j = 0;
				int cnt = rnd.Next(5);

				while (j < cnt)
				{
					j++;

					text.AddLineBreak();
					text.AddContent("... extra text line");
					text.AddContent(j.ToString(), style2);
				}
			}

			// Publish
			report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF);
			report.Publish("Document.xps", Siberix.Report.FileFormat.XPS);

			// Save
			report.Save("Report.xml");

			// View
			System.Diagnostics.Process process = new System.Diagnostics.Process();
			System.Diagnostics.ProcessStartInfo info = new System.Diagnostics.ProcessStartInfo("Document.pdf");
			process.StartInfo = info;
			process.Start();
		}
	}
}