Imports System
Imports System.Collections.Generic

Module Example

    Private Class Item

        Public Title As String
        Public Quantity As Integer
        Public UnitPrice As Decimal

        Public ReadOnly Property TotalPrice As Decimal

            Get
                Return UnitPrice * Quantity
            End Get

        End Property

    End Class

    Private Class Invoice

        Public ContactPhone As String = "(555) 555 - 5555"
        Public ContactFax As String = "(555) 555 - 7777"
        Public BillToName As String = "Contact name"
        Public BillToAddress As String = "Contact address"
        Public ShipToName As String = "Contact name"
        Public ShipToAddress As String = "Contact address"
        Public Total As Decimal

        Public Items As List(Of Item) = New List(Of Item)

        Public Sub New()

            ' Items
            Dim rnd As System.Random = New System.Random()

            For i As Integer = 1 To 65
                Dim item As Item = New Item()

                item.Title = "Item " + i.ToString()
                item.Quantity = rnd.Next(5) + 1
                item.UnitPrice = rnd.Next(500) + CType(rnd.Next(100) / 100, Decimal)

                Items.Add(item)

                Total += item.TotalPrice
            Next

        End Sub

    End Class

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        Dim invoice As Invoice = New Invoice()

        report.DataContext = New Siberix.Report.Data.DataContext("dc1", invoice)

        report.Delegates.OnTextInjectorDelegate = Sub(id As String, text As Siberix.Report.Text.IText, style As Siberix.Report.Text.Style, hyperlink As Siberix.Report.Text.Hyperlink)

                                                      If id = "ContactEmail" Then
                                                          text.AddContent("contact@domain.com", style, New Siberix.Report.Text.Hyperlink("mailto:contact@domain.com"))
                                                      End If

                                                  End Sub

        ' Load
        report.Load("../../Invoice.xml")

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
