Imports System
Imports System.Collections.Generic

Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black)
        Dim style2 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(10), Siberix.Graphics.Brushes.DarkGreen)
        Dim style3 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.ArialBold(12), Siberix.Graphics.Brushes.DarkBlue)
        Dim style4 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(38), Siberix.Graphics.Brushes.Red)

        ' Flow
        Dim flow As Siberix.Report.Flow.IFlow = section.AddFlow()

        Dim column As Siberix.Report.Flow.IColumn = flow.AddColumn()
        column.Width = New Siberix.Report.RelativeWidth(50)
        column.Borders.Right = New Siberix.Report.Border(Siberix.Graphics.Pens.DarkBlue)
        column.Paddings.Right = 10

        column = flow.AddColumn()
        column.Width = New Siberix.Report.RelativeWidth(50)
        column.Paddings.Left = 10

        ' Left-aligned paragraph
        Dim text As Siberix.Report.Text.IText = flow.AddText()
        text.Style = style3
        text.KeepWithNext = True
        text.AddContent("Left-aligned paragraph")

        text = flow.AddText()
        text.Style = style1
        text.Interval = 2
        text.Indent = 50
        text.Spacings.Top = 10
        text.Spacings.Bottom = 20
        text.Alignment = Siberix.Report.TextAlignment.Left
        text.AddContent("Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

        ' Right-aligned paragraph
        text = flow.AddText()
        text.Style = style3
        text.KeepWithNext = True
        text.AddContent("Right-aligned paragraph")

        text = flow.AddText()
        text.Style = style1
        text.Interval = 2
        text.Indent = 50
        text.Spacings.Top = 10
        text.Spacings.Bottom = 20
        text.Alignment = Siberix.Report.TextAlignment.Right
        text.AddContent("Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

        ' Centered paragraph
        text = flow.AddText()
        text.Style = style3
        text.KeepWithNext = True
        text.AddContent("Centered paragraph")

        text = flow.AddText()
        text.Style = style1
        text.Interval = 2
        text.Spacings.Top = 10
        text.Spacings.Bottom = 20
        text.Alignment = Siberix.Report.TextAlignment.Center
        text.AddContent("Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

        ' Justified paragraph
        text = flow.AddText()
        text.Style = style3
        text.KeepWithNext = True
        text.AddContent("Justified paragraph")

        text = flow.AddText()
        text.Style = style1
        text.Interval = 2
        text.Indent = 50
        text.Spacings.Top = 10
        text.Spacings.Bottom = 20
        text.Alignment = Siberix.Report.TextAlignment.Justify
        text.AddContent("Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

        ' Multiple styles
        text = flow.AddText()
        text.Style = style3
        text.KeepWithNext = True
        text.AddContent("Multiple styles")

        text = flow.AddText()
        text.Style = style1
        text.Interval = 2
        text.Indent = 50
        text.Spacings.Top = 10
        text.Spacings.Bottom = 30
        text.Alignment = Siberix.Report.TextAlignment.Justify
        text.AddContent("Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. ")
        text.AddContent("Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.", style2)

        ' Text with a leader
        text = flow.AddText()
        text.Style = style3
        text.AddContent("Text with a leader")

        text = flow.AddText()
        text.Style = style1
        text.Interval = 2
        text.Spacings.Top = 10
        text.Spacings.Bottom = 20
        text.Leader = New Siberix.Report.Text.Leader(".")
        text.AddContent("Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

        ' Text with a drop-cap
        text = flow.AddText()
        text.Style = style3
        text.AddContent("Text with a drop-cap")

        text = flow.AddText()
        text.Style = style1
        text.Interval = 2
        text.Spacings.Top = 10
        text.Spacings.Bottom = 20
        text.DropCap = New Siberix.Report.Text.DropCap("A", style4)
        text.DropCap.Spacings.Right = 7

        text.AddContent("marone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
