Imports System
Imports System.Collections.Generic

Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black)

        Dim style2 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Red)
        style2.FontVariant = Siberix.Report.FontVariant.Subscript

        Dim style3 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(16), Siberix.Graphics.Brushes.White)

        ' Grid
        Dim grid As Siberix.Report.Grid.IGrid = section.AddGrid()
        grid.StretchOnBreak = True
        grid.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        grid.Borders.Corners.TopLeft.Pen = Siberix.Graphics.Pens.Black
        grid.Borders.Corners.TopLeft.Radius = 10
        grid.Borders.Corners.BottomLeft.Pen = Siberix.Graphics.Pens.Black
        grid.Borders.Corners.BottomLeft.Radius = 10

        Dim column As Siberix.Report.Grid.IColumn = grid.AddColumn()
        column.Width = New Siberix.Report.RelativeWidth(20)

        column = grid.AddColumn()
        column.Width = New Siberix.Report.DirectWidth(100)

        column = grid.AddColumn()
        column.Width = New Siberix.Report.RelativeWidth(20)

        column = grid.AddColumn()
        column.Width = New Siberix.Report.RelativeWidth(30)

        column = grid.AddColumn()
        column.Width = New Siberix.Report.RelativeWidth(30)

        ' Header
        Dim header As Siberix.Report.Grid.IHeader = grid.AddHeader()
        header.Repeat = True

        Dim row As Siberix.Report.Grid.IRow = header.AddRow()
        row.Height = New Siberix.Report.DirectHeight(35)

        Dim cell As Siberix.Report.Grid.ICell = row.AddCell()
        cell.ColSpan = 5
        cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Borders.Corners.TopLeft.Pen = Siberix.Graphics.Pens.Black
        cell.Borders.Corners.TopLeft.Radius = 10
        cell.Background = New Siberix.Report.Background(New Siberix.Graphics.Color(235, 50, 50))

        Dim text As Siberix.Report.Text.IText = cell.AddText()
        text.Width = New Siberix.Report.RelativeWidth(100)
        text.Style = style3
        text.Alignment = Siberix.Report.TextAlignment.Center
        text.AddContent("Header")

        ' Footer
        Dim footer As Siberix.Report.Grid.IFooter = grid.AddFooter()
        footer.Repeat = True

        row = footer.AddRow()
        row.Height = New Siberix.Report.DirectHeight(35)

        cell = row.AddCell()
        cell.ColSpan = 5
        cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Borders.Corners.BottomLeft.Pen = Siberix.Graphics.Pens.Black
        cell.Borders.Corners.BottomLeft.Radius = 10
        cell.Background = New Siberix.Report.Background(New Siberix.Graphics.Color(50, 200, 200))

        text = cell.AddText()
        text.Width = New Siberix.Report.RelativeWidth(100)
        text.Style = style3
        text.Alignment = Siberix.Report.TextAlignment.Center
        text.AddContent("Footer")

        ' Last footer
        Dim lastFooter As Siberix.Report.Grid.IFooter = grid.AddFooter()
        lastFooter.Repeat = False

        row = lastFooter.AddRow()
        row.Height = New Siberix.Report.DirectHeight(55)

        cell = row.AddCell()
        cell.ColSpan = 5
        cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Borders.Corners.BottomLeft.Pen = Siberix.Graphics.Pens.Black
        cell.Borders.Corners.BottomLeft.Radius = 10
        cell.Background = New Siberix.Report.Background(New Siberix.Graphics.Color(125, 50, 200))

        text = cell.AddText()
        text.Width = New Siberix.Report.RelativeWidth(100)
        text.Style = style3
        text.Alignment = Siberix.Report.TextAlignment.Center
        text.AddContent("Last Footer")

        row = grid.AddRow()

        cell = row.AddCell()
        cell.RowSpan = 2
        cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Paddings.All = 5

        text = cell.AddText()
        text.Style = style1
        text.AddContent("row")
        text.AddContent("1", style2)
        text.AddContent(" cell")
        text.AddContent("1", style2)
        text.AddContent(" content...")

        cell = row.AddCell()
        cell.RowSpan = 4
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Paddings.All = 5

        text = cell.AddText()
        text.Style = style1
        text.AddContent("row")
        text.AddContent("1", style2)
        text.AddContent(" cell")
        text.AddContent("2", style2)
        text.AddContent(" content... Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

        cell = row.AddCell()
        cell.RowSpan = 2
        cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Paddings.All = 5

        text = cell.AddText()
        text.Style = style1
        text.AddContent("row")
        text.AddContent("1", style2)
        text.AddContent(" cell")
        text.AddContent("3", style2)
        text.AddContent(" content...")

        cell = row.AddCell()
        cell.ColSpan = 2
        cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Paddings.All = 5

        text = cell.AddText()
        text.Style = style1
        text.AddContent("row")
        text.AddContent("1", style2)
        text.AddContent(" cell")
        text.AddContent("4", style2)
        text.AddContent(" content...")

        row = grid.AddRow()

        cell = row.AddCell()
        cell.ColSpan = 2
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Paddings.All = 5

        text = cell.AddText()
        text.Style = style1
        text.AddContent("row")
        text.AddContent("2", style2)
        text.AddContent(" cell")
        text.AddContent("1", style2)
        text.AddContent(" content... Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique.")

        row = grid.AddRow()

        cell = row.AddCell()
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Paddings.All = 5

        text = cell.AddText()
        text.Style = style1
        text.AddContent("row")
        text.AddContent("3", style2)
        text.AddContent(" cell")
        text.AddContent("1", style2)
        text.AddContent(" content...")

        cell = row.AddCell()
        cell.ColSpan = 2
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Paddings.All = 5

        text = cell.AddText()
        text.Style = style1
        text.AddContent("row")
        text.AddContent("3", style2)
        text.AddContent(" cell")
        text.AddContent("2", style2)
        text.AddContent(" content...")
        text.Spacings.Bottom = 5

        Dim image As Siberix.Report.IImage = cell.AddImage(New Siberix.Graphics.Image("../../image.jpg"))
        image.Width = New Siberix.Report.RelativeWidth(100)

        cell = row.AddCell()
        cell.RowSpan = 2
        cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Paddings.All = 5
        cell.Background = New Siberix.Report.Background(New Siberix.Graphics.Color(230, 230, 230))

        text = cell.AddText()
        text.Style = style1
        text.AddContent("row")
        text.AddContent("3", style2)
        text.AddContent(" cell")
        text.AddContent("3", style2)
        text.AddContent(" content...")

        row = grid.AddRow()

        cell = row.AddCell()
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Paddings.All = 5

        text = cell.AddText()
        text.Style = style1
        text.AddContent("row")
        text.AddContent("4", style2)
        text.AddContent(" cell")
        text.AddContent("1", style2)
        text.AddContent(" content...")

        cell = row.AddCell()
        cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Bottom
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Paddings.All = 5
        cell.Background = New Siberix.Report.Background(New Siberix.Graphics.Color(230, 230, 230))

        text = cell.AddText()
        text.Style = style1
        text.AddContent("row")
        text.AddContent("4", style2)
        text.AddContent(" cell")
        text.AddContent("2", style2)
        text.AddContent(" content...")

        cell = row.AddCell()
        cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Bottom
        cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
        cell.Paddings.All = 5

        text = cell.AddText()
        text.Style = style1
        text.AddContent("row")
        text.AddContent("4", style2)
        text.AddContent(" cell")
        text.AddContent("3", style2)
        text.AddContent(" content...")

        Dim rnd As System.Random = New System.Random()

        For i As Integer = 5 To 21

            row = grid.AddRow()

            cell = row.AddCell()
            cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
            cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle
            cell.Paddings.All = 5

            text = cell.AddText()
            text.Style = style1
            text.AddContent("row")
            text.AddContent(i.ToString(), style2)
            text.AddContent(" cell")
            text.AddContent("1", style2)
            text.AddContent(" content...")

            cell = row.AddCell()
            cell.ColSpan = 4
            cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
            cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle
            cell.Paddings.All = 5

            text = cell.AddText()
            text.Style = style1
            text.Spacings.Bottom = 5
            text.AddContent("row")
            text.AddContent(i.ToString(), style2)
            text.AddContent(" cell")
            text.AddContent("2", style2)
            text.AddContent(" content... Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

            Dim j As Integer = 0
            Dim cnt As Integer = rnd.Next(5)

            While j < cnt

                j += 1

                text.AddLineBreak()
                text.AddContent("... extra text line")
                text.AddContent(j.ToString(), style2)

            End While

        Next

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
