Imports System
Imports System.Collections.Generic

Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black)

        Dim style2 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Red)
        style2.FontVariant = Siberix.Report.FontVariant.Subscript

        Dim rnd As System.Random = New System.Random()

        For i As Integer = 1 To 25

            ' Group
            Dim group As Siberix.Report.IGroup = section.AddGroup()
            group.Borders = New Siberix.Report.Borders(New Siberix.Graphics.Pen(Siberix.Graphics.Colors.Black, 1.5F), 5)
            group.Background.Brush = Siberix.Graphics.Brushes.Azure
            group.Width = New Siberix.Report.RelativeWidth(35.0F + CType(65.0 * rnd.NextDouble(), Single))
            group.Paddings.All = 5
            group.Spacings.Bottom = 5

            Dim text As Siberix.Report.Text.IText = group.AddText()
            text.Style = style1
            text.AddContent("Group")
            text.AddContent(i.ToString(), style2)

            Dim j As Integer = 0
            Dim cnt As Integer = rnd.Next(5)

            While j < cnt

                j += 1

                text.AddLineBreak()
                text.AddContent("... extra text line")
                text.AddContent(j.ToString(), style2)

            End While

        Next

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
