Imports System
Imports System.Collections.Generic

Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(10), Siberix.Graphics.Brushes.DarkBlue)
        style1.Underline = Siberix.Graphics.Pens.DarkBlue

        ' Hyperlinks
        Dim text As Siberix.Report.Text.IText = section.AddText()
        text.Style = style1
        text.Spacings.Top = 5
        text.Id = "Link1"
        text.AddContent("Next link", New Siberix.Report.Text.Hyperlink("Link2"))

        text = section.AddText()
        text.Style = style1
        text.Spacings.Top = 5
        text.Id = "Link2"
        text.AddContent("Previous link", New Siberix.Report.Text.Hyperlink("Link1"))

        text = section.AddText()
        text.Style = style1
        text.Spacings.Top = 5
        text.AddContent("Link to www.siberix.com", New Siberix.Report.Text.Hyperlink("http://www.siberix.com"))

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
