Imports System
Imports System.Collections.Generic

Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black)

        ' Shapes
        Dim site As Siberix.Report.ISite = section.AddSite()

        ' Rectangle
        Dim rectangle As Siberix.Report.Shapes.IRectangle = site.Shapes.AddRectangle()
        rectangle.Pen = New Siberix.Graphics.Pen(Siberix.Graphics.Colors.Red, 5)
        rectangle.Brush = New Siberix.Graphics.SolidColorBrush(New Siberix.Graphics.Color(255, 240, 240))
        rectangle.X = 30
        rectangle.Y = 30
        rectangle.Width = 150
        rectangle.Height = 100
        rectangle.Radius = 5
        rectangle.Angle = 15

        Dim label As Siberix.Report.Shapes.ILabel = site.Shapes.AddLabel()
        label.Font = style1.Font
        label.Brush = Siberix.Graphics.Brushes.Black
        label.X = 60
        label.Y = 30
        label.Text = "Rectangle"
        label.Angle = 15

        ' Line
        Dim line As Siberix.Report.Shapes.ILine = site.Shapes.AddLine()
        line.Pen = New Siberix.Graphics.Pen(Siberix.Graphics.Colors.Green, 5)
        line.X1 = 220
        line.Y1 = 30
        line.X2 = 320
        line.Y2 = 130

        label = site.Shapes.AddLabel()
        label.Font = style1.Font
        label.Brush = Siberix.Graphics.Brushes.Black
        label.X = 250
        label.Y = 35
        label.Text = "Line"
        label.Angle = 45

        ' Ellipse
        Dim ellipse As Siberix.Report.Shapes.IEllipse = site.Shapes.AddEllipse()
        ellipse.Pen = New Siberix.Graphics.Pen(Siberix.Graphics.Colors.Blue, 5)
        ellipse.Brush = New Siberix.Graphics.SolidColorBrush(New Siberix.Graphics.Color(240, 240, 255))
        ellipse.X = 350
        ellipse.Y = 30
        ellipse.Width = 150
        ellipse.Height = 100
        ellipse.Angle = -20

        label = site.Shapes.AddLabel()
        label.Font = style1.Font
        label.Brush = Siberix.Graphics.Brushes.Black
        label.X = 400
        label.Y = 80
        label.Text = "Ellipse"
        label.Angle = -20

        ' Polyline
        Dim polyline As Siberix.Report.Shapes.IPolyline = site.Shapes.AddPolyline()
        polyline.Pen = New Siberix.Graphics.Pen(Siberix.Graphics.Colors.Green, 5, Siberix.Graphics.DashStyle.DashDot)

        Dim points As Siberix.Graphics.PointCollection = New Siberix.Graphics.PointCollection()
        points.Add(30, 200)
        points.Add(185, 220)
        points.Add(150, 350)
        points.Add(125, 260)
        points.Add(70, 300)
        polyline.Points = points

        label = site.Shapes.AddLabel()
        label.Font = style1.Font
        label.Brush = Siberix.Graphics.Brushes.Black
        label.X = 70
        label.Y = 220
        label.Text = "Polyline"
        label.Angle = 5

        ' Polygon
        Dim polygon As Siberix.Report.Shapes.IPolygon = site.Shapes.AddPolygon()
        polygon.Pen = New Siberix.Graphics.Pen(Siberix.Graphics.Colors.Goldenrod, 5)
        polygon.Brush = New Siberix.Graphics.SolidColorBrush(New Siberix.Graphics.Color(250, 250, 245))
        points = New Siberix.Graphics.PointCollection()
        points.Add(230, 200)
        points.Add(385, 220)
        points.Add(350, 350)
        points.Add(270, 300)
        polygon.Points = points

        label = site.Shapes.AddLabel()
        label.Font = style1.Font
        label.Brush = Siberix.Graphics.Brushes.Black
        label.X = 270
        label.Y = 220
        label.Text = "Polygon"
        label.Angle = 5

        ' Pie
        Dim pie As Siberix.Report.Shapes.IPie = site.Shapes.AddPie()
        pie.Pen = New Siberix.Graphics.Pen(Siberix.Graphics.Colors.DarkOrchid, 5)
        pie.Brush = New Siberix.Graphics.SolidColorBrush(New Siberix.Graphics.Color(250, 230, 250))
        pie.X = 400
        pie.Y = 230
        pie.Width = 100
        pie.Height = 100
        pie.StartAngle = -45
        pie.EndAngle = 265

        label = site.Shapes.AddLabel()
        label.Font = style1.Font
        label.Brush = Siberix.Graphics.Brushes.Black
        label.X = 450
        label.Y = 290
        label.Text = "Pie"
        label.Angle = -40

        ' Path
        Dim path As Siberix.Report.Shapes.IPath = site.Shapes.AddPath()
        path.Pen = New Siberix.Graphics.Pen(Siberix.Graphics.Colors.DarkBlue, 5, Siberix.Graphics.DashStyle.DashDotDot)
        path.Brush = New Siberix.Graphics.SolidColorBrush(New Siberix.Graphics.Color(250, 250, 245))
        path.MoveTo(100, 400)
        path.LineTo(300, 500)
        path.CurveTo(120, 560, 100, 520, 70, 480)
        path.CurveTo(320, 360, 200, 320, 150, 600)
        path.ClosePath()

        label = site.Shapes.AddLabel()
        label.Font = style1.Font
        label.Brush = Siberix.Graphics.Brushes.Black
        label.X = 140
        label.Y = 460
        label.Text = "Path"

        ' Arc
        Dim arc As Siberix.Report.Shapes.IArc = site.Shapes.AddArc()
        arc.Pen = New Siberix.Graphics.Pen(Siberix.Graphics.Colors.Red, 5)
        arc.X = 370
        arc.Y = 420
        arc.Width = 100
        arc.Height = 100
        arc.StartAngle = -45
        arc.EndAngle = 265

        label = site.Shapes.AddLabel()
        label.Font = style1.Font
        label.Brush = Siberix.Graphics.Brushes.Black
        label.X = 430
        label.Y = 415
        label.Text = "Arc"
        label.Angle = 15

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
