Imports System
Imports System.Collections.Generic

Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black)

        Dim style2 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Red)
        style2.FontVariant = Siberix.Report.FontVariant.Subscript

        Dim img As Siberix.Graphics.Image = New Siberix.Graphics.Image("../../image.jpg")

        Dim rnd As System.Random = New System.Random()

        For i As Integer = 0 To 5

            ' Slot
            Dim slot As Siberix.Report.Slot.ISlot = section.AddSlot()
            slot.StretchOnBreak = True
            slot.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
            slot.Spacings.Bottom = 5

            Dim cell As Siberix.Report.Slot.ICell = slot.AddCell()
            cell.Width = New Siberix.Report.RelativeWidth(30)
            cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
            cell.Background.Brush = Siberix.Graphics.Brushes.WhiteSmoke
            cell.Paddings.All = 5

            Dim text As Siberix.Report.Text.IText = cell.AddText()
            text.Style = style1
            text.AddContent("Slot")
            text.AddContent((i + 1).ToString(), style2)
            text.AddLineBreak()
            text.AddContent("cell")
            text.AddContent("1", style2)
            text.AddContent(" content...")

            Dim group As Siberix.Report.IGroup = cell.AddGroup()
            group.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.DarkBlue)
            group.Width = New Siberix.Report.RelativeWidth(90)
            group.Spacings.Top = 10

            Dim image As Siberix.Report.IImage = group.AddImage(img)
            image.Width = New Siberix.Report.RelativeWidth(100)

            cell = slot.AddCell()
            cell.Width = New Siberix.Report.DirectWidth(100)
            cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
            cell.Paddings.All = 5
            cell.Background.Brush = Siberix.Graphics.Brushes.Lavender

            text = cell.AddText()
            text.Style = style1
            text.AddContent("cell")
            text.AddContent("2", style2)
            text.AddContent(" content... Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

            Dim j As Integer = 0
            Dim cnt As Integer = rnd.Next(5)

            While j < cnt

                j += 1

                text.AddLineBreak()
                text.AddContent("... extra text line")
                text.AddContent(j.ToString(), style2)

            End While

            cell = slot.AddCell()
            cell.Width = New Siberix.Report.RelativeWidth(70)
            cell.Alignment.Vertical = Siberix.Report.VerticalAlignment.Middle
            cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
            cell.Background.Brush = Siberix.Graphics.Brushes.WhiteSmoke
            cell.Paddings.All = 5

            text = cell.AddText()
            text.Style = style1
            text.AddContent("cell")
            text.AddContent("3", style2)
            text.AddContent(" content...")

            j = 0
            cnt = rnd.Next(5)

            While j < cnt

                j += 1

                text.AddLineBreak()
                text.AddContent("... extra text line")
                text.AddContent(j.ToString(), style2)

            End While

        Next

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
